<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2005 Alfred A. Hummer (web-admin@aah.at)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'guestbook' for the 'aahbook_plus' extension.
 *
 * @author	Alfred A. Hummer <web-admin@aah.at>
 */


require_once(PATH_tslib.'class.tslib_pibase.php');

class tx_aahbookplus_pi1 extends tslib_pibase {
	var $prefixId = 'tx_aahbookplus_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_aahbookplus_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'aahbook_plus';	// The extension key.
	var $data;  
	  
	function urlcheck($url){
    	$url = trim($url);
		if (strstr($url, 'http://') == FALSE) {
			$url = 'http://'.$url;
		}

		if($url) {
       		$fp = @fopen ($url, "r");
    	}
		if($fp){
       		return $url;
       		fclose($fp);
   		} else {
        	return false;
   		}
 	}

	function url_syntax($url, $urltext){
    	$url = trim($url);
		$urltext = trim($urltext);
		if (strstr($url,'http://') == FALSE) {
			$url = 'http://'.$url;
		}
		if ($urltext != '') {
			$url = $this->cObj->getTypoLink($urltext,$url,array(),'_blank');
			return $url;
		}
		else {
			$url = $this->cObj->getTypoLink($url,$url,array(),'_blank');
			return $url;
		}
  }

	function bbcode($bbcode) {
		$bbcode = addslashes(htmlspecialchars(stripslashes ($bbcode)));
		$bbcode = preg_replace('/\[b\](.*?)\[\/b\]/si', '<b>\\1</b>', $bbcode);
		$bbcode = preg_replace('/\[i\](.*?)\[\/i\]/si', '<i>\\1</i>', $bbcode);
		$bbcode = preg_replace('/\[s\](.*?)\[\/s\]/si', '<s>\\1</s>', $bbcode);
		$bbcode = preg_replace('/\[u\](.*?)\[\/u\]/si', '<u>\\1</u>', $bbcode);
		$bbcode = preg_replace('/\[center\](.*?)\[\/center\]/si', '<center>\\1</center>', $bbcode);
		$bbcode = preg_replace('/\[url\](.*?)\[\/url\]/e', "\$this->url_syntax('\\1','')", $bbcode);
		$bbcode = preg_replace('/\[url(.*?)\](.*?)\[\/url\]/e', "\$this->url_syntax('\\1','\\2')",$bbcode);
		$bbcode = preg_replace('/\[url(.*?)\](.*?)\[\/url\]/e', "\$this->url_syntax('\\1','\\2')",$bbcode);

		return $bbcode;
	}

	function smilies_src() {	
	 if ($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'smilies_dir', 'sDEF')) {
			$path = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'smilies_dir', 'sDEF'); 			
		} else {
			$path = t3lib_extMgm::siterelpath('aahbook_plus').'images/';
		}
		return $path;		
	}
	function bbcode_src() {
	
	 if ($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'bbcode_dir', 'sDEF')) {
			$path = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'bbcode_dir', 'sDEF'); 			
		} else {
			$path = t3lib_extMgm::siterelpath('aahbook_plus').'images/';
		}
		return $path;		
	}
	
	function smilies($text) {		
		$path=$this->smilies_src();
		$smilies = array(
			':smile:'	=>	'<img src="'.$path.'s1.gif" alt=":)" border="0"/>&nbsp;',
			':twinky:'	=>	'<img src="'.$path.'s2.gif" alt=";)" border="0"/>&nbsp;',
			':b_smile:'	=>	'<img src="'.$path.'s3.gif" alt=":D" border="0"/>&nbsp;',
			':tongue:'	=>	'<img src="'.$path.'s4.gif" alt=":L" border="0"/>&nbsp;',
			':eyes:'	=>	'<img src="'.$path.'s5.gif" alt=",)" border="0"/>&nbsp;',
			':o_mouth:'	=>	'<img src="'.$path.'s6.gif" alt=":o" border="0"/>&nbsp;',
			':b_eyes:'	=>	'<img src="'.$path.'s7.gif" alt=";o" border="0"/>&nbsp;',
			':walk:'	=>	'<img src="'.$path.'s8.gif" alt=";(" border="0"/>&nbsp;',
			':sad:'   	=>	'<img src="'.$path.'s9.gif" alt=":(" border="0"/>&nbsp;',
			':angry:'	=>	'<img src="'.$path.'s10.gif" alt=",(" border="0"/>&nbsp;',
			':devil:'	=>	'<img src="'.$path.'s11.gif" alt=";|" border="0"/>&nbsp;',
			':ill:'	    =>	'<img src="'.$path.'s12.gif" alt=":(" border="0"/>&nbsp;',
			':mad:' 	=>	'<img src="'.$path.'s13.gif" alt=";O" border="0"/>&nbsp;',
			':bigeyes:'	=>	'<img src="'.$path.'s14.gif" alt=":o" border="0"/>&nbsp;',
			':irate:'	=>	'<img src="'.$path.'s15.gif" alt=";L" border="0"/>&nbsp;',
		);

		$text = strtr($text, $smilies);
		return $text;
	}

	function kopf() {
	 	$head = "";
		# Get the parts out of the template
		$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_HEADER###');

		switch ($this->piVars['task']) {
			case 'new':
				$markerArray['###HREF_HEAD###'] = $this->pi_linkToPage($this->pi_getLL('to_entries'),$GLOBALS['TSFE']->id,"",array());
			break;

			default:
				$markerArray['###HREF_HEAD###'] = $this->pi_linkToPage($this->pi_getLL('new_entry'),$GLOBALS['TSFE']->id,"",array($this->prefixId.'[task]'=>'new'));
		}

		$head = $this->cObj->substituteMarkerArrayCached($template["total"],$markerArray, array(), array());
		return $head;
	}

	/**
	 * Abrufen der Daten aus der Datenbanktabelle
	 */
	function getentries() {
		$data = "";
		#Check if the $page variable is set, if not set it to 1
		$page = $this->piVars['page'];
		if(!isset($page)) {
   			$page = 1;
   	}

		#Set how many entries per page you want to have:
		$entries_page = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'entries_perpage', 'sDEF');
		if ($entries_page == '') {
			$entries_page = 8;
		}
		#Calculate the start value of the row to read from the entries
		$start = $page * $entries_page - $entries_page;

		#count the number of rows
		$res = $GLOBALS['TYPO3_DB']->sql(TYPO3_db, 'SELECT uid FROM tx_aahbook_plus_entries WHERE hidden = 0');
		$amount = $GLOBALS['TYPO3_DB']->sql_num_rows($res);

		#calculate the amount of page-links
		$amount_page = ceil($amount / $entries_page);
		if ($amount == 0) {
			$markerArray['###HREF_PAGE###'] .= ' <b>1</b> ';
		}

		#check if $amount_page ist bigger than the $page_max integer from the plugin flexform
		$page_max = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'page_max', 'sDEF');
		if ($amount_page > $page_max and $page_max > 10) {
			$amount_page_new = 5;
			if ($this->piVars['page'] > 1) {
				$markerArray['###HREF_PAGE###'] .= $this->pi_linkToPage('&lt;&lt;'.$this->pi_getLL('gb_back'),$GLOBALS['TSFE']->id,"",array($this->prefixId.'[page]' => $this->piVars['page'] - 1)).'&nbsp;';
			} else {
				$markerArray['###HREF_PAGE###'] .= '<b>'.$this->pi_getLL('gb_begin').'</b>&nbsp;';
			}
		} else {
			$amount_page_new = $amount_page;
		}

		#for loop to output the links to the various pages
		for($a=0; $a < $amount_page_new; $a++) {
   			$b = $a + 1;
			if($page == $b) {
      			$markerArray['###HREF_PAGE###'] .= '<b>'.$b.'</b>&nbsp;';
				$content_item_page .= $this->cObj->substituteMarkerArrayCached($template["item"], $markerArray, array(), array());
			} else {
				$markerArray['###HREF_PAGE###'] .= $this->pi_linkToPage($b,$GLOBALS['TSFE']->id,"",array($this->prefixId.'[page]' => $b)).'&nbsp;';
   			}
		}

		#If the amount of pagelinks is greater than the $page_max variable
		if ($amount_page > $page_max and $page_max > 10) {
			$amount_page_end = $amount_page - 5;
			if ($this->piVars['page'] - 1 > $amount_page_new + 1 and $this->piVars['page'] <= $amount_page_end) {
				$markerArray['###HREF_PAGE###'] .= '<b>...</b>&nbsp;'.$this->pi_linkToPage($this->piVars['page'] - 1,$GLOBALS['TSFE']->id,"",array('page'=> $this->piVars['page'] - 1)).'&nbsp;<b>';
			} else if ($this->piVars['page'] - 1 == $amount_page_new) {
				$markerArray['###HREF_PAGE###'] .= '<b>';
			} else if ($this->piVars['page'] - 1 == $amount_page_new + 1) {
				$markerArray['###HREF_PAGE###'] .= $this->pi_linkToPage($this->piVars['page'] - 1,$GLOBALS['TSFE']->id,"",array('page'=> $this->piVars['page'] - 1)).'&nbsp;<b>';
			}

			if ($this->piVars['page'] > $amount_page_new and $this->piVars['page'] <= $amount_page_end) {
				$markerArray['###HREF_PAGE###'] .= $this->piVars['page'].'</b>&nbsp;';
			}

			if ($this->piVars['page'] > $amount_page_new and $this->piVars['page'] + 1 <= $amount_page_end) {
				$markerArray['###HREF_PAGE###'] .= $this->pi_linkToPage($this->piVars['page'] + 1,$GLOBALS['TSFE']->id,"",array('page'=> $this->piVars['page'] + 1)).'&nbsp;';
			}

			if ($this->piVars['page'] + 1 == $amount_page_end or $this->piVars['page'] == $amount_page_end) {
				$markerArray['###HREF_PAGE###'] .= '';
			} else {
				$markerArray['###HREF_PAGE###'] .= '<b>...</b>&nbsp;';
			}

			for($a = $amount_page_end; $a < $amount_page; $a++) {
				$b = $a + 1;
				if($page == $b) {
					$markerArray['###HREF_PAGE###'] .= '<b>'.$b.'</b>&nbsp;';
					$content_item_page .= $this->cObj->substituteMarkerArrayCached($template["item"], $markerArray, array(), array());
				} else {
					$markerArray['###HREF_PAGE###'] .= $this->pi_linkToPage($b,$GLOBALS['TSFE']->id,"",array('page'=>$b)).'&nbsp;';
				}
			}
			if ($this->piVars['page'] < $amount_page and $this->piVars['page'] != '') {
				$markerArray['###HREF_PAGE###'] .= $this->pi_linkToPage($this->pi_getLL('gb_forward').'&gt;&gt;',$GLOBALS['TSFE']->id,"",array('page'=> $this->piVars['page'] + 1));
			} else if ($this->piVars['page'] == '') {
				$markerArray['###HREF_PAGE###'] .= $this->pi_linkToPage($this->pi_getLL('gb_forward').'&gt;&gt;',$GLOBALS['TSFE']->id,"",array('page'=>1 + 1));
			} else {
				$markerArray['###HREF_PAGE###'] .= '<b>'.$this->pi_getLL('gb_end').'</b>';
			}
		}

		# Get the parts out of the template
		$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_ENTRIES###');
		$template["item"] = $this->cObj->getSubpart($template["total"],'###AAHBOOK_ITEM###');
		$template["url"] = $this->cObj->getSubpart($template["item"],'###URL###');

		#Get date and time format:
		$date_format = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'date_format', 'sDEF');
		$time_format = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'time_format', 'sDEF');
		if ($date_format == '') {
			$date_format = '%A, %d %B %Y';
		} else {
			$date_format = $date_format;
		}
		if ($time_format == '') {
			$time_format = '%H:%M';
		} else {
			$time_format = $time_format;
		}

		$res = $GLOBALS['TYPO3_DB']->sql(TYPO3_db, 'SELECT * FROM tx_aahbook_plus_entries WHERE hidden = 0 ORDER BY crdate DESC LIMIT '.$start.','.$entries_page);
		while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
 			# Build content from template

			$markerArray['###EMAIL###'] = $this->cObj->getTypoLink($row['name'],$row['email']);
			$markerArray['###DATE###'] = $this->pi_getLL('date_on').strftime($date_format,$row['crdate']).$this->pi_getLL('date_at').strftime($time_format,$row['crdate']);
			if ($row['url'] != '') {
				$subpartArray['###URL###'] =$this->cObj->substituteMarkerArrayCached($template["url"],
						array (
							'###URL_LINK###' => $this->pi_getLL('webpage').$this->cObj->getTypoLink($row['url'],$row['url'],array(),'_blank'),
						)
				);
			} else {
				$subpartArray['###URL###'] = '';
			}
			$markerArray['###TEXT###'] = nl2br($this->smilies($this->bbcode($row['text'])));

			#Get the class definitions
			#Insert different colors into the guestbook
			if ($i % 2) {
				$markerArray['###CLASS_ITEM###'] = $this->pi_getClassName('item_even');
			} else {
				$markerArray['###CLASS_ITEM###'] = $this->pi_getClassName('item_odd');
			}
    		$i++;

			$content_item .= $this->cObj->substituteMarkerArrayCached($template["item"], $markerArray, $subpartArray, array());
		}

		if ($amount == 0) {
			$subpartArray["###ENTRIES###"] = '<p>'.$this->pi_getLL('no_entries').'</p>';
		} else {
			$subpartArray["###ENTRIES###"] = $content_item;
		}
		$markerArray['###PAGE###'] = $this->pi_getLL('page');

		$data = $this->cObj->substituteMarkerArrayCached($template["total"], $markerArray, $subpartArray, array());
		return $data;
	}

	function newentry() {
		unset($_SESSION[$this->prefixId]['form_valid']);
		$newentry = "";

		# Get the parts out of the template
		$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_NEW###');
		$template["captcha"] = $this->cObj->getSubpart($template["total"],'###CAPTCHA###');
		$template["smilies"] = $this->cObj->getSubpart($template["total"],'###SMILIES###');
		$template["bbcode"] = $this->cObj->getSubpart($template["total"],'###BBCODE###');
		$template["helpbox"] = $this->cObj->getSubpart($template["total"],'###HELPBOX###');
		$template["js"] = $this->cObj->getSubpart($this->templateCode,'###JS_ARRAYS###');

		#Check if the user is logged in
    /*
    if ($GLOBALS['TSFE']->loginUser) {
      		$markerArray['###USERNAME###'] = 'value="'.$GLOBALS['TSFE']->fe_user->user['username'].'" readonly="readonly"';
      		$markerArray['###USEREMAIL###'] = 'value="'.$GLOBALS['TSFE']->fe_user->user['email'].'" readonly="readonly"';
		} else {
      		$markerArray['###USERNAME###'] = '';
			    $markerArray['###USEREMAIL###'] = '';
		}
    */

		$markerArray['###NAME###'] = $this->pi_getLL('name');
		$markerArray['###EMAIL###'] = $this->pi_getLL('email');
		$markerArray['###URL###'] = $this->pi_getLL('url');
		$markerArray['###URL_FORMAT###'] = $this->pi_getLL('url_format');
		$markerArray['###TEXT###'] = $this->pi_getLL('text');
		$markerArray['###SUBMIT###'] = $this->pi_getLL('submit');
		$markerArray['###MUST###'] = $this->pi_getLL('must');
		$markerArray['###ACTION###'] = $this->pi_getPageLink($GLOBALS['TSFE']->id,'',array($this->prefixId.'[task]'=>'submit','L' => $GLOBALS["TSFE"]->config["config"]["sys_language_uid"]));

		#Check if bbCode is set or not
		
		$bbcode_set = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'show_bbcode', 'sDEF');
		if ($bbcode_set == 1) {		  
		  $bbcode_src = $this->bbcode_src();
		  
			#These pictures are from the chc-forum extension!
			$subpartArray['###BBCODE###'] = $this->cObj->substituteMarker($template["bbcode"],'###BBCODE_BTNS###',
					'
					<img src="'.$bbcode_src.'bold.png" onClick="bbtext(0)" onmouseover="helpline(0)" />
					<img src="'.$bbcode_src.'italic.png" onClick="bbtext(2)" onmouseover="helpline(1)" />
					<img src="'.$bbcode_src.'underline.png" onClick="bbtext(4)" onmouseover="helpline(2)" />
					<img src="'.$bbcode_src.'url.png" onClick="bbtext(8)" onmouseover="helpline(4)" />
					');
			$markerArray['###HELP0###'] = $this->pi_getLL('help0');
			$markerArray['###HELP1###'] = $this->pi_getLL('help1');
			$markerArray['###HELP2###'] = $this->pi_getLL('help2');
			$markerArray['###HELP4###'] = $this->pi_getLL('help4');
		} else {
			$supartArray['###BBCODE###'] = '';
		}

		#Check if Smilies is set or not
		$smilies_set = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'show_smilies', 'sDEF');
		if ($smilies_set == 1) {
			$smilies_src = $this->smilies_src();
			for ($i = 1; $i <= 15; $i++) {
				$s_imgs.='<img src="'.$smilies_src.'s'.$i.'.gif" onClick="smilie('.($i-1).')" onmouseover="helpsmilie(0)" />&nbsp;';
				$markerArray['###HELP_SMILIE###'] = $this->pi_getLL('help_smilie');
			}
			$subpartArray['###SMILIES###'] = $this->cObj->substituteMarker($template["smilies"],'###SMILIES_BTNS###',$s_imgs);
		} else {
			$subpartArray['###SMILIES###'] = '';
			$markerArray['###HELP_SMILIE###'] = '';
		}

		#Check if helpbox is needed
		if ($smilies_set == 0 and $bbcode_set == 0) {
			$subpartArray['###HELPBOX###'] = '';
		} else {
			$subpartArray['###HELPBOX###'] =
					$this->cObj->substituteMarker($template["helpbox"],'###HELPBOX_FIELD###',
						'<input type="text" disabled="disabled" name="helpbox" value="'.$this->pi_getLL('helpbox').'" />');
		}

		#Check if captcha is set or not
		$captcha_set = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'show_captcha', 'sDEF');
		if (t3lib_extMgm::isLoaded('sr_freecap') and $captcha_set == 1)	{
			$subpartArray['###CAPTCHA###'] =$this->cObj->substituteMarkerArrayCached($template["captcha"],
				array (
					'###CAPTCHA_TEXT###' => $this->pi_getLL('captcha'),
					'###CAPTCHA_IMG###' => '<img src="'.t3lib_extMgm::siterelpath('sr_freecap').'pi1/captcha.php" alt="" />',
				)
			);
		} else {
			$subpartArray['###CAPTCHA###'] = '';
		}

    //fill in fields from Session (on Error/back)
    $markerArray['###VALUE_NAME###']=$_SESSION[$this->prefixId]['name'];
    $markerArray['###VALUE_EMAIL###']=$_SESSION[$this->prefixId]['email'];
    $markerArray['###VALUE_URL###']=$_SESSION[$this->prefixId]['url'];
    $markerArray['###VALUE_TEXT###']=$_SESSION[$this->prefixId]['text'];
/*
    echo'<pre style="font-size:12px;text-align:left;">';
		echo "Marker:\n";
		print_r($markerArray);
		echo'</pre>';
*/
		$newentry = $this->cObj->substituteMarkerArrayCached($template["js"],$markerArray, array(), array());
		$newentry .= $this->cObj->substituteMarkerArrayCached($template["total"],$markerArray, $subpartArray, array());
		return $newentry;
	}

	function submit() {
		#preprocess data
		array_walk($this->piVars,create_function('&$arr','$arr=trim($arr);'));

    #store data to session
		(!empty($this->piVars)) && $_SESSION[$this->prefixId]=$this->piVars;
/*
		echo'<pre style="font-size:12px;text-align:left;">';
		echo "\nAFTER:\n";
		echo "SESSION:\n";
		print_r($_SESSION[$this->prefixId]);
		echo "\nPiVars:\n";
		print_r($this->piVars);
		echo'</pre>';
*/

		#Validate form fields
		$Error=FALSE;

		#Captcha stuff
		$captcha_set = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'show_captcha', 'sDEF');
		if ($captcha_set == 1 and t3lib_extMgm::isLoaded('sr_freecap')) {
			$captchaStr = $_SESSION['sr_freecap_word_hash'];
			if (md5($this->piVars['captcharesponse']) == $captchaStr and $captchaStr != '') {
				$markerArray['###ERROR_CAPTCHA###'] = '';
			} else {
				$markerArray['###ERROR_CAPTCHA###'] = $this->pi_getLL('error_captcha').'<br />';
				$Error=TRUE;
			}
		} else {
			$markerArray['###ERROR_CAPTCHA###'] = '';
		}

    #Name
		if (empty($this->piVars['name'])) {
			$markerArray['###ERROR_NAME###'] = $this->pi_getLL('error_name').'<br />';
			$Error=TRUE;
		} else {
			$markerArray['###ERROR_NAME###'] = '';
		}

		#Email
		if (empty($this->piVars['email'])) {
			$markerArray['###ERROR_EMAIL###'] = $this->pi_getLL('error_email').'<br />';
		} else {
			if ($this->cObj->checkEmail($this->piVars['email'])) {
				$markerArray['###ERROR_EMAIL###'] = '';
			} else {
			  $Error=TRUE;
				$markerArray['###ERROR_EMAIL###'] = $this->pi_getLL('error_email_syntax').'<br />';
			}
		}

		#URL
		if (!empty($this->piVars['url'])) {
			$check_url = $this->urlcheck($this->piVars['url']);
			if ($check_url == FALSE) {
				$markerArray['###ERROR_URL###'] = $this->pi_getLL('error_url').'<br />';
				$Error=TRUE;
			} else {
				$markerArray['###ERROR_URL###'] = '';
				$markerArray['###URL_CHECK_VAR###'] = $this->piVars['url'];
			}
		} else {
			$markerArray['###ERROR_URL###'] = '';
			$markerArray['###URL_CHECK_VAR###'] = $this->pi_getLL('no_url').'<br />';
		}

		#Text
		if (empty($this->piVars['text'])) {
			$markerArray['###ERROR_TEXT###'] = $this->pi_getLL('error_text').'<br />';
			$Error=TRUE;
		} else {
			$markerArray['###ERROR_TEXT###'] = '';
		}

		if (!$Error) {
			$checkdata = '';
			# Get the parts out of the template
			$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_CHECKDATA###');

			$markerArray['###CHECK_DATA###'] = $this->pi_getLL('check_data');
			$markerArray['###NAME_CHECK###'] = $this->pi_getLL('name');
			$markerArray['###NAME_CHECK_VAR###'] = $name;
			$markerArray['###EMAIL_CHECK###'] = $this->pi_getLL('email');
			$markerArray['###EMAIL_CHECK_VAR###'] = $email;
			$markerArray['###URL_CHECK###'] = $this->pi_getLL('url');
			$markerArray['###TEXT_CHECK###'] = $this->pi_getLL('text');
			$markerArray['###TEXT_CHECK_VAR###'] = nl2br($this->smilies($this->bbcode($this->piVars['text'])));
			$markerArray['###VAL_TEXT###'] = $text;
			$markerArray['###BACK###'] = $this->pi_getLL('back');
			$markerArray['###HREF_INSERT###'] =$this->pi_getPageLink($GLOBALS['TSFE']->id,'',array($this->prefixId.'[task]'=>'insert','L' => $GLOBALS["TSFE"]->config["config"]["sys_language_uid"]));
			$markerArray['###TEXT_INSERT###'] = $this->pi_getLL('text_insert');

			$checkdata = $this->cObj->substituteMarkerArrayCached($template["total"],$markerArray, array(), array());
			$_SESSION[$this->prefixId]['form_valid']=TRUE;
			return $checkdata;

		} else {
			$submitentry = "";
			# Get the parts out of the template
			$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_SUBMIT###');
      $markerArray['###HREF_NEW###'] = $this->pi_getPageLink($GLOBALS['TSFE']->id,'',array($this->prefixId.'[task]'=>'new','L' => $GLOBALS["TSFE"]->config["config"]["sys_language_uid"]));
			$markerArray['###BACK###'] = $this->pi_getLL('back');

			$submitentry = $this->cObj->substituteMarkerArrayCached($template["total"],$markerArray, array(), array());
			return $submitentry;
		}
	}

	function insert() {
			if ($_SESSION[$this->prefixId]['form_valid']) {
				$insertFields = array(
    			'name' 	=> $_SESSION[$this->prefixId]['name'],
    			'email' => $_SESSION[$this->prefixId]['email'],
    			'url' 	=> $_SESSION[$this->prefixId]['url'],
    			'text' 	=> $_SESSION[$this->prefixId]['text'],
					'crdate'=> time(),
					'tstamp'=> time(),
					'pid' 	=> $GLOBALS['TSFE']->id,
				);

				$GLOBALS['TYPO3_DB']->exec_INSERTquery(
				'tx_aahbook_plus_entries',
    			$insertFields
				);
			}
			unset($_SESSION[$this->prefixId]['text']);
			unset($_SESSION[$this->prefixId]['form_valid']);

			$insertentry = "";
			# Get the parts out of the template
			$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_INSERT###');

			$markerArray['###SUCCESS###'] = $this->pi_getLL('success');
			$markerArray['###HREF_BACK_ENTRIES###'] = $this->pi_linkToPage($this->pi_getLL('to_entries'),$GLOBALS['TSFE']->id,"",array());

			$insertentry = $this->cObj->substituteMarkerArrayCached($template["total"],$markerArray, array(), array());
			return $insertentry;
	}

	/**
	 * Footer des Gstebuches
	 */
	function footer() {
		$foot = "";
		# Get the parts out of the template
		$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_FOOTER###');

		$markerArray['###HREF_POWERED_BY###'] = $this->cObj->getTypoLink($this->pi_getLL('powered_by').' AAH &copy; '.strftime('%Y', time()),'http://typo3.aah.at',array(),'_blank');

		$foot = $this->cObj->substituteMarkerArrayCached($template["total"],$markerArray, array(), array());
		return $foot;
	}

	/**
	 * Ausgabe des Content
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_initPIflexForm();
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
		$GLOBALS['TSFE']->additionalHeaderData['includeJS']='<script language="JavaScript" type="text/javascript" src="'.t3lib_extMgm::siterelpath('aahbook_plus').'pi1/script.js"></script>';
		session_start();
/*
		echo'<pre style="font-size:12px;text-align:left;">';
		echo "SESSION:\n";
		print_r($_SESSION[$this->prefixId]);
		echo "\nPiVars:\n";
		print_r($this->piVars);
		echo'</pre>';
*/
		# Get the template
		$this->templateCode = $this->cObj->fileResource($conf["templateFile"]);
 		if ($this->templateCode=="") {
			return '<h3>'.$this->pi_getLL('no_template').'</h3>'.$this->conf['templateFile'];
		}

		switch ($this->piVars["task"]) {
			case 'new':
				$content= $this->kopf().$this->newentry().$this->footer();
			break;

			case 'submit':
				$content= $this->submit().$this->footer();
			break;

			case 'insert':
				$content= $this->insert().$this->footer();
			break;

			default:
				$content= $this->kopf().$this->getentries().$this->footer();
		}

		return $this->pi_wrapInBaseClass($content);
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/aahbook_plus/pi1/class.tx_aahbookplus_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/aahbook_plus/pi1/class.tx_aahbookplus_pi1.php']);
}

?>